

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define N 100000000

int write_files()
{
  int i;
  int *a;
  FILE *ascii, *bin;
  clock_t start, diff1, diff2;

  ascii = fopen("test.asc", "w");
  bin = fopen("test.bin", "wb");
  
  if((ascii == NULL) || (bin == NULL)) {
    fprintf(stderr, "Could not open files. \n");
    return -1;
  }
  
  a = (int*) malloc(N*sizeof(int));
  if (a == NULL) {
    fprintf(stderr, "Could not allocate array (write). \n");
    return -1;
  }
  
  for(i = 0; i < N; i++) {
    a[i] = i%1000;           // some values
  }
  
  start = clock();
  for(i = 0; i < N; i++) {
    fprintf(ascii, "%d", a[i]);
  }
  fflush(ascii);
  diff1 = clock() - start;
  
  start = clock();
  fwrite(a, sizeof(int), N, bin);
  fflush(bin);
  diff2 = clock() - start;
  
  printf("Writing to ascii file: %lu ms, writing to binary file: %lu ms \n", diff1*1000/CLOCKS_PER_SEC, diff2*1000/CLOCKS_PER_SEC);
  
  free(a);
  fclose(bin);
  fclose(ascii);
  return 0;
}

int read_files()
{
  int i;
  int *a;
  FILE *ascii, *bin;
  clock_t start, diff1, diff2;

  ascii = fopen("test.asc", "r");
  bin = fopen("test.bin", "r");
  
  if((ascii == NULL) || (bin == NULL)) {
    fprintf(stderr, "Could not open files. \n");
    return -1;
  }
  
  a = (int*) malloc(N*sizeof(int));
  if (a == NULL) {
    fprintf(stderr, "Could not allocate array (read). \n");
    return -1;
  }
  
  start = clock();
  for(i = 0; i < N; i++) {
    fscanf(ascii, "%d", &a[i]);
  }
  diff1 = clock() - start;
  
  start = clock();
  fread(a, sizeof(int), N, bin);
  fflush(bin);
  diff2 = clock() - start;

  printf("Reading from ascii file: %lu ms, Reading from binary file: %lu ms \n", diff1*1000/CLOCKS_PER_SEC, diff2*1000/CLOCKS_PER_SEC);
  
  free(a);

  fclose(ascii);
  fclose(bin);

  return 0;
}

int main()
{
  int i = write_files();
  if (i != 0)
    return i;
  return read_files();
}
